-- Gestion du stockage partag

gShared={};
gShared.shared = gPlayer:GetSharedStorage();
gShared.data = Kiki.Commons.Settings(gPluginName.."_shared", {} );

-- Initialiser  NIL si besoin, si aucun element rcupr depuis la sauvegarde
if gShared.data[gLanguage]==nil then gShared.data[gLanguage]={}; end

-- Recharge le contenu du stockage
gShared.Refresh = function()

	if gShared.shared:IsAvailable() == false then
		Kiki.Commons.Trace("SharedStorage not available");
		return;
	end
	local size=gShared.shared:GetCount();
	if size == 0 then
		-- Mise  jour diffre
		Kiki.Commons.Trace("SharedStorage available but update delayed");
		return;
	end
	
	Kiki.Commons.Trace("SharedStorage in progress, size="..size);
	local filled = 0;
	for i=1,size do
		tmpItem=gShared.shared:GetItem(i);
		if tmpItem==nil then
			gShared.data[gLanguage][i]={i=i,name="",qty=0,imgId=0};
		else
			filled=filled+1;
			local itemInfo=tmpItem:GetItemInfo();
			gShared.data[gLanguage][i]= {i=i,name=itemInfo:GetName(),qty=tmpItem:GetQuantity(),imgId=itemInfo:GetIconImageID()};
			-- Kiki.Commons.Trace(dump(gShared.data[gLanguage][i]));
		end
	end
	gShared.data.Filled=filled;
	gShared.data.Capacity=size;
end

-- dump le contenu du stockage partag
gShared.Dump = function()
	for k,v in pairs(gShared.data[gLanguage]) do
		Kiki.Commons.Trace(k.."="..v.name.." ("..v.qty..")");
	end
end
-- Recherche un element dans le shared storage
gShared.Search=function(txt)
	local ret = {};
	local usr = gPlayerName;
	local s =string.lower(txt);
	for i,desc in pairs(gShared.data[gLanguage]) do
		if string.find(string.lower(desc.name), s,1,true) ~= nil then
			-- found !!
			if ret[usr] == nil then ret[usr]={} end
			if ret[usr][desc.name]==nil then
				ret[usr][desc.name] = desc.qty;
			else
				ret[usr][desc.name] = ret[usr][desc.name] + desc.qty;
			end
		end
	end
	return ret;
end

-- Callbacks
gShared.IsAvailableChanged = function(sender, args)
	gShared.Refresh();
end
gShared.ItemsRefreshed = function(sender, args)
	gShared.Refresh();
end
gShared.CountChanged = function(sender, args)
	gShared.Refresh();
end
gShared.CapacityChanged = function(sender, args)
	gShared.Refresh();
end

-- Initialisation des callbacks
gShared.AddCallBacks = function()
	AddCallback(gShared.shared,"IsAvailableChanged",gShared.IsAvailableChanged);
	AddCallback(gShared.shared,"ItemsRefreshed",gShared.ItemsRefreshed);
	-- AddCallback(gShared.shared,"ChestChanged",gShared.Refresh);
	-- AddCallback(gShared.shared,"ChestNameChanged",gShared.Refresh);
	AddCallback(gShared.shared,"CountChanged",gShared.CountChanged);
	AddCallback(gShared.shared,"CapacityChanged",gShared.CapacityChanged);
end

-- Suppression des callbakcs
gShared.RemoveCallBacks = function()
	RemoveCallback(gShared.shared,"IsAvailableChanged",gShared.IsAvailableChanged);
	RemoveCallback(gShared.shared,"ItemsRefreshed",gShared.ItemsRefreshed);
	RemoveCallback(gShared.shared,"CountChanged",gShared.CountChanged);
	RemoveCallback(gShared.shared,"CapacityChanged",gShared.CapacityChanged);
end


gShared.Unload = function()
	gShared.RemoveCallBacks();
	gShared.data:Save(gPluginName.."_shared");
end


-- Initialisation
gShared.Load=function()
	gShared.AddCallBacks();
	gShared.Refresh();
end


