-- Gestion du stockage partag

gVault={};
gVault.vault = gPlayer:GetVault();
gVault.data = Kiki.Commons.Settings(gPluginName.."_vault", {} );

if gVault.data[gPlayerName]== nil then gVault.data[gPlayerName]={}; end
if gVault.data[gPlayerName][gLanguage]==nil then gVault.data[gPlayerName][gLanguage]={}; end

-- Recharge le contenu du stockage
gVault.Refresh = function()

	if gVault.vault:IsAvailable() == false then
		Kiki.Commons.Trace("Vault not available");
		return;
	end
	local size=gVault.vault:GetCount();
	if size == 0 then
		-- Mise  jour diffre
		Kiki.Commons.Trace("Vault available but update delayed");
		return;
	end
	
	Kiki.Commons.Trace("Vault introspection in progress, size="..size);
	local filled = 0;
	for i=1,size do
		tmpItem=gVault.vault:GetItem(i);
		if tmpItem==nil then
			gVault.data[gPlayerName][gLanguage][i]={i=i,name="",qty=0,imgId=0};
		else
			filled=filled+1;
			local itemInfo=tmpItem:GetItemInfo();
			gVault.data[gPlayerName][gLanguage][i]= {i=i,name=itemInfo:GetName(),qty=tmpItem:GetQuantity(),imgId=itemInfo:GetIconImageID()};
			-- Kiki.Commons.Trace(dump(gVault.data[gLanguage][i]));
		end
	end
	gVault.data[gPlayerName].Filled=filled;
	gVault.data[gPlayerName].Capacity=size;
end

-- dump le contenu du coffre
gVault.Dump = function()
	for usr,elt in pairs(gVault.data) do
		for i,desc in pairs(elt[gLanguage]) do
			Kiki.Commons.Trace(usr.."="..desc.name.." ("..desc.qty..")");
		end
	end
end
-- Recherche un element du coffre
gVault.Search=function(txt)
	local ret = {};
	local s = string.lower(txt);
	for usr,elt in pairs(gVault.data) do
		for i,desc in pairs(elt[gLanguage]) do
			if string.find(string.lower(desc.name), s,1,true) ~= nil then
				-- found !!
				if ret[usr] == nil then ret[usr]={} end
				if ret[usr][desc.name]==nil then
					ret[usr][desc.name] = desc.qty;
				else
					ret[usr][desc.name] = ret[usr][desc.name] + desc.qty;
				end
			end
		end
	end
	return ret;
end

-- Callbacks
gVault.IsAvailableChanged = function(sender, args)
	gVault.Refresh();
end
gVault.ItemsRefreshed = function(sender, args)
	gVault.Refresh();
end
gVault.CountChanged = function(sender, args)
	gVault.Refresh();
end
gVault.CapacityChanged = function(sender, args)
	gVault.Refresh();
end

-- Initialisation des callbacks
gVault.AddCallBacks = function()
	AddCallback(gVault.vault,"IsAvailableChanged",gVault.IsAvailableChanged);
	AddCallback(gVault.vault,"ItemsRefreshed",gVault.ItemsRefreshed);
	-- AddCallback(gVault.vault,"ChestChanged",gVault.Refresh);
	-- AddCallback(gVault.vault,"ChestNameChanged",gVault.Refresh);
	AddCallback(gVault.vault,"CountChanged",gVault.CountChanged);
	AddCallback(gVault.vault,"CapacityChanged",gVault.CapacityChanged);
end

-- Suppression des callbakcs
gVault.RemoveCallBacks = function()
	RemoveCallback(gVault.vault,"IsAvailableChanged",gVault.IsAvailableChanged);
	RemoveCallback(gVault.vault,"ItemsRefreshed",gVault.ItemsRefreshed);
	RemoveCallback(gVault.vault,"CountChanged",gVault.CountChanged);
	RemoveCallback(gVault.vault,"CapacityChanged",gVault.CapacityChanged);
end


gVault.Unload = function()
	gVault.RemoveCallBacks();
	gVault.data:Save(gPluginName.."_vault");
end


-- Initialisation
gVault.Load=function()
	gVault.AddCallBacks();
	gVault.Refresh();
end


